package net.ihe.gazelle.tempgen.sequoia.scripts;

import net.ihe.gazelle.tempapi.visitor.DecorVisitor;
import net.ihe.gazelle.tempmodel.org.decor.art.model.Decor;
import net.ihe.gazelle.tempmodel.org.decor.art.model.Vocabulary;
import net.ihe.gazelle.tempmodel.org.decor.art.utils.DecorMarshaller;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Unmarshaller.Listener;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.Arrays;
import java.util.List;

public class CCDAForceValueSetWithNHIW {

    public static void main(String[] args) throws FileNotFoundException, JAXBException {
        String bbrinput = "/YOUR/PATH/TO/BBR/bbr.xml";
        String bbroutput = "/YOUR/PATH/TO/OUTPUT/output.xml";


        List<String> listOID = Arrays.asList("2.16.840.1.113883.11.20.9.47", "2.16.840.1.113883.11.20.9.46", "2.16.840.1.113883.1.11.16866",
                "2.16.840.1.113883.1.11.15933",
                "2.16.840.1.113762.1.4.1021.30", "2.16.840.1.113883.1.11.1", "2.16.840.1.113883.1.11.20.2", "2.16.840.1.113883.3.88.12.3221.6.2",
                "2.16.840.1.113883.3.88.12.3221.8.9", "2.16.840.1.113762.1.4.1010.6", "2.16.840.1.113883.11.20.9.61", "2.16.840.1.113762.1.4.1099.10",
                "2.16.840.1.113762.1.4.1010.2", "2.16.840.1.113883.11.20.9.31", "2.16.840.1.113883.1.11.18877", "2.16.840.1.113883.1.11.20549",
                "2.16.840.1.113883.11.20.9.29", "2.16.840.1.113762.1.4.1099.4", "2.16.840.1.114222.4.11.877", "2.16.840.1.113762.1.4.1095.59",
                "2.16.840.1.113883.11.20.4.1", "2.16.840.1.113883.11.20.9.52", "2.16.840.1.113883.3.88.12.80.32", "2.16.840.1.113762.1.4.1095.51",
                "2.16.840.1.113883.1.11.15913", "2.16.840.1.113883.11.20.9.26", "2.16.840.1.114222.4.11.837", "2.16.840.1.113883.1.11.19579",
                "2.16.840.1.113762.1.4.1095.87", "2.16.840.1.113883.1.11.10416", "2.16.840.1.113762.1.4.1095.82", "2.16.840.1.113883.11.20.9.55",
                "2.16.840.1.113883.1.11.16926", "2.16.840.1.113883.1.11.20.22", "2.16.840.1.113883.1.11.20.12", "2.16.840.1.113883.11.20.9.51",
                "2.16.840.1.114222.4.11.1066", "2.16.840.1.113883.1.11.20275", "2.16.840.1.113883.11.20.9.33", "1.3.6.1.4.1.12009.10.2.5",
                "2.16.840.1.113883.1.11.12249", "2.16.840.1.113883.1.11.12199", "2.16.840.1.113883.1.11.12212", "2.16.840.1.113762.1.4.1010.4",
                "2.16.840.1.113883.3.88.12.80.64", "2.16.840.1.113762.1.4.1099.12", "2.16.840.1.113762.1.4.1099.11", "2.16.840.1.113883.11.20.9.44",
                "2.16.840.1.113883.11.20.9.18", "2.16.840.1.113883.1.11.19717", "2.16.840.1.113883.11.20.9.68", "2.16.840.1.113762.1.4.1095.75",
                "2.16.840.1.113762.1.4.1095.85", "2.16.840.1.113762.1.4.1095.81", "2.16.840.1.113762.1.4.1095.49", "2.16.840.1.113762.1.4.1095.58",
                "2.16.840.1.113762.1.4.1095.65", "2.16.840.1.113883.1.11.20.2.9", "2.16.840.1.113883.1.11.20.2.7", "2.16.840.1.113762.1.4.1",
                "2.16.840.1.113883.1.11.78", "2.16.840.1.113883.1.11.10267", "2.16.840.1.113883.1.11.10901", "2.16.840.1.113883.11.20.9.34",
                "2.16.840.1.113883.11.20.9.66", "2.16.840.1.114222.4.11.3591", "2.16.840.1.113883.11.20.12.1", "2.16.840.1.113883.11.20.9.65",
                "2.16.840.1.113883.11.20.9.54", "2.16.840.1.113883.11.20.9.23", "2.16.840.1.113883.11.20.9.25", "2.16.840.1.113883.11.20.9.24",
                "2.16.840.1.113883.1.11.10637", "2.16.840.1.113883.11.20.9.36", "2.16.840.1.113883.11.20.9.35", "2.16.840.1.113883.11.20.9.60",
                "2.16.840.1.113883.3.88.12.3221.7.4", "2.16.840.1.113883.3.88.12.80.68", "2.16.840.1.113883.3.88.12.3221.7.2",
                "2.16.840.1.113883.11.20.9.19",
                "2.16.840.1.113883.3.88.12.80.28", "2.16.840.1.113883.11.20.9.22", "2.16.840.1.113883.11.20.6.1", "2.16.840.1.113883.11.20.8.1",
                "2.16.840.1.113883.3.2074.1.1.3", "2.16.840.1.113883.1.11.14914", "2.16.840.1.113883.3.88.12.3221.6.8",
                "2.16.840.1.113883.11.20.9.56",
                "2.16.840.1.113883.1.11.20.2.3", "2.16.840.1.113883.1.11.19185", "2.16.840.1.113883.11.20.9.49", "2.16.840.1.113883.11.20.9.39",
                "2.16.840.1.113883.3.88.12.3221.8.7", "2.16.840.1.113883.11.20.9.50", "2.16.840.1.113883.11.20.9.38",
                "2.16.840.1.113883.3.88.12.80.60",
                "2.16.840.1.113762.1.4.1010.1", "2.16.840.1.113883.11.20.7.1", "2.16.840.1.113883.11.20.1.1", "2.16.840.1.113883.11.20.9.37",
                "2.16.840.1.113883.11.20.9.20", "2.16.840.1.113883.11.20.9.41", "2.16.840.1.113883.1.11.20.2.4", "2.16.840.1.113883.1.11.12839",
                "2.16.840.1.113762.1.4.1010.8", "2.16.840.1.113883.3.88.12.80.62", "2.16.840.1.113883.11.20.9.58", "2.16.840.1.113883.1.11.20.2.5",
                "2.16.840.1.113883.1.11.20.2.6", "2.16.840.1.113883.1.11.11610", "2.16.840.1.113883.1.11.19601");
        Decor dec = loadDecor(new FileInputStream(bbrinput), listOID);
        DecorMarshaller.marshallDecor(dec, new FileOutputStream(bbroutput));
    }

    public static Decor loadDecor(InputStream is, final List<String> listOID) throws JAXBException {
        JAXBContext jc = JAXBContext.newInstance(Decor.class);
        Unmarshaller u = jc.createUnmarshaller();
        u.setListener(new Listener() {

            @Override
            public void afterUnmarshal(Object target, Object parent) {
                super.afterUnmarshal(target, parent);
                if (target instanceof Vocabulary) {
                    Vocabulary vocab = (Vocabulary) target;
                    if (vocab.getValueSet() != null && listOID.contains(vocab.getValueSet())) {
                        if (vocab.getFlexibility() == null || vocab.getFlexibility().equals("dynamic")) {
                            vocab.setFlexibility("C-CDA R2.1 2021-08-10");
                            System.out.println(vocab.getValueSet());
                        }
                    }
                }
            }
        });
        Decor res = (Decor) u.unmarshal(is);
        DecorVisitor.INSTANCE.visitAndProcess(res, new VocabCheckImplProvider());
        updateDecorContent(res);
        return res;
    }

    private static void updateDecorContent(Decor res) {
        if (res != null) {
            res.setDatasets(null);
            res.setIds(null);
            res.setIssues(null);
            res.setScenarios(null);
        }
    }

}
